import { NavigableSet } from '../../../java/util/NavigableSet';
import { JavaIterator } from '../../../java/util/JavaIterator';
import { Collection } from '../../../java/util/Collection';
import { JavaObject } from '../../../java/lang/JavaObject';
import { SortedSet } from '../../../java/util/SortedSet';
import { AVLMapSubMap } from '../../../core/adt/map/AVLMapSubMap';
import { Comparator } from '../../../java/util/Comparator';
export declare class AVLMapSubKeySet<K, V> extends JavaObject implements NavigableSet<K> {
    private readonly _sub;
    /**
     * Erstellt eine neues Sub-Set auf die übergebene {@link AVLMap}.
     *
     * @param sub Die {@link AVLMap} auf der operiert wird.
     */
    constructor(sub: AVLMapSubMap<K, V>);
    toString(): String;
    comparator(): Comparator<Partial<K>>;
    first(): K;
    last(): K;
    size(): number;
    isEmpty(): boolean;
    contains(o: unknown): boolean;
    toArray(): Array<unknown>;
    toArray<T>(a: Array<T>): Array<T>;
    add(e: K): boolean;
    remove(o: unknown): boolean;
    containsAll(c: Collection<unknown>): boolean;
    addAll(c: Collection<K>): boolean;
    retainAll(c: Collection<unknown>): boolean;
    removeAll(c: Collection<unknown>): boolean;
    clear(): void;
    lower(e: K): K | null;
    floor(e: K): K | null;
    ceiling(e: K): K | null;
    higher(e: K): K | null;
    pollFirst(): K | null;
    pollLast(): K | null;
    iterator(): JavaIterator<K>;
    descendingSet(): NavigableSet<K>;
    descendingIterator(): JavaIterator<K>;
    subSet(fromElement: K, fromInclusive: boolean, toElement: K, toInclusive: boolean): NavigableSet<K>;
    subSet(fromElement: K, toElement: K): SortedSet<K>;
    headSet(toElement: K, inclusive: boolean): NavigableSet<K>;
    headSet(toElement: K): SortedSet<K>;
    tailSet(fromElement: K, inclusive: boolean): NavigableSet<K>;
    tailSet(fromElement: K): SortedSet<K>;
    isTranspiledInstanceOf(name: string): boolean;
    [Symbol.iterator](): Iterator<K>;
}
export declare function cast_de_nrw_schule_svws_core_adt_map_AVLMapSubKeySet<K, V>(obj: unknown): AVLMapSubKeySet<K, V>;
